//
//  CitrouilleService.m
//  Citrouille
//
//  Created by Alexandre Colucci on 28/03/10.
//  Copyright 2010 Alexandre Colucci. All rights reserved.
//

#import "CitrouilleService.h"


@implementation CitrouilleService

- (void)doPasteAsPlainText:(NSPasteboard *)pboard userData:(NSString *)userData error:(NSString **)error
{
	NSString *outString = @"";
	BOOL hasError = NO;
	
	if(!hasError)
	{
		// Test for strings on the pasteboard.
		NSArray *classes = [NSArray arrayWithObject:[NSString class]];
		NSDictionary *options = [NSDictionary dictionary];
		
		if (![[NSPasteboard generalPasteboard] canReadObjectForClasses:classes options:options])
		{
			outString = @"";
			hasError = YES;
			*error = NSLocalizedString(@"Error: There is no string in the pasteboard.", @"outputing nothing");
		}
	}
	
	if(!hasError)
	{
		outString = [[NSPasteboard generalPasteboard] stringForType:NSPasteboardTypeString];
		if(outString == nil)
		{
			outString = @"";
			hasError = YES;
			*error = NSLocalizedString(@"Error: There is no valid string in the pasteboard.", @"outputing nothing");
		}
	}
	
	
	// Write the string onto the pasteboard.
	[pboard clearContents];
	[pboard writeObjects:[NSArray arrayWithObject:outString]];
}

- (void)doCopyAsPlainText:(NSPasteboard *)pboard userData:(NSString *)userData error:(NSString **)error
{
	// Test for strings on the pasteboard.
	NSArray *classes = [NSArray arrayWithObject:[NSString class]];
	NSDictionary *options = [NSDictionary dictionary];
	
	if (![pboard canReadObjectForClasses:classes options:options])
	{
		*error = NSLocalizedString(@"Error: couldn't get text.", @"pboard couldn't give string.");
		return;
	}
	
	NSString *pboardString = [pboard stringForType:NSPasteboardTypeString];
	[[NSPasteboard generalPasteboard] clearContents];
	[[NSPasteboard generalPasteboard]  writeObjects:[NSArray arrayWithObject:pboardString]];
}

@end
